local HEALTH_LABEL = GetModConfigData("HEALTH LABEL")
if not HEALTH_LABEL then return end

local ST = GLOBAL.STRINGS
local Y_ = 5
local MAX_Amount = 12
local Current_Amount = 0

local function LabelSetPos(inst)
local PP=4
		local time,live_time = 0,100
		local y = PP
		local y_a,y_b = .0025,.0075
		local A_A,a_a,A_a = true,false,true 
	inst:StartThread(function()
		while inst:IsValid() and time < live_time do
			time = time + 1	
			y_a = y_a + y_b
			y = y + y_a 
			if y > PP + 2 and A_A then 
				y_b = -y_b
				A_A = false 
				a_a = true 
			elseif y < PP +2 and a_a and A_a then
				y_b = -y_b*2.2
				A_a = false 
			end
			inst.Label:SetFontSize( 50 * math.sqrt(y/(PP+10)))
			inst.Label:SetPos(0, y-Y_,0)
			GLOBAL.Sleep(.02)
		end
	inst:Remove()
	Current_Amount = Current_Amount-1
	end)
end

local function LabelsSetPos(inst) --这个参考了s1m13的
		local time = 0
		local live_time = 50 --刷新50次，50*.02=1s
		local x = 0
		local x_a = .3 --控制向左走的距离
		local x_b = math.random()*.02 --概率,是一直向左或折回，以及走的速度快慢
		local y = 3
		local y_a = .025
		local y_b = .05
	inst:StartThread(function()
		while inst:IsValid() and time < live_time do
			time = time + 1	
			x_a = x_a - x_b
			x = x + x_a
			y_a = y_a - y_b
			y = y + y_a 
			if y < 0 then
				y = -y
				y_a = -y_a*.9
			end
			
			inst.Label:SetFontSize( 50 * math.sqrt(1 - time / live_time)) -----好强大--开始完全没想到改变数字大小
			inst.Label:SetPos(x, y-Y_,0)
			GLOBAL.Sleep(.02)
		end
	inst:Remove()
	Current_Amount = Current_Amount-1
	end)
end

local function AddHealthLabel(self,amount,currenthealth)
	if Current_Amount >= MAX_Amount then return end
	if math.abs(amount) >= 1 and currenthealth > 0 and self.inst.components.health:IsHurt() then
		local x,y,z = self.inst.Transform:GetWorldPosition() --似乎变峰猪的瞬间会出错
		if not x then return end
		local Hp_base = GLOBAL.CreateEntity() --原来是直接在本体上加Label的，会移动。。。而且不好控制（在数值改变的时候）
		local trans = Hp_base.entity:AddTransform()
		trans:SetPosition(x,y+Y_,z)
		Hp_base.entity:AddLabel()
		local HL = Hp_base.Label
		HL:SetFont(GLOBAL.BODYTEXTFONT)
		if amount < 0 then
			HL:SetColour(.6,.4,.2)
		else
			HL:SetColour(.2,.6,.4)
		end
		HL:Enable(true)
		
		if self:GetPercent() <= 0 and HEALTH_LABEL == 'A' then
			local str =  self.inst:HasTag('player') and ST.PLAYERDEATHSTR or ST.DEATHSTR
			HL:SetText(str..string.upper(self.inst.prefab).."*")
				--HL:SetText(..string.upper(self.inst.prefab)..'*!!!')
			LabelSetPos(Hp_base)
		else
			amount = currenthealth + amount < 0 and currenthealth or amount
			HL:SetText(string.format('%d',amount))
			LabelsSetPos(Hp_base)
		end
	Current_Amount = Current_Amount+1	
	end
end

local function LabelPostInit(self, inst)
	local OldFn = self.DoDelta
	function self:DoDelta(amount, overtime, cause, ignore_invincible)
		local currenthealth = self.currenthealth
		OldFn(self,amount, overtime, cause, ignore_invincible)
		AddHealthLabel(self,amount,currenthealth)
	end
end

AddComponentPostInit("health",LabelPostInit)